
-- PERF_PROGRAMMA_MUSICALE
-- PERF_UTILIZZAZIONE

-- PERF_MOVIMENTO_CONTABILE
-- PERF_EVENTI_PAGATI
-- PERF_DIRETTORE_ESECUZIONE
-- PERF_MANIFESTAZIONE


-- DB SUN:
--Test	
--connection: 	dboratest-scan.servizi.siae:1521/SPTEST.NET.SIAE			
--username: 	preprod_user	
--password: 	P73P70D_US34

--Produzione	
--connection: 	dbsun-scan.servizi.siae:1521/SPPRD.NET.SIAE			
--username: 	spei_reader	
--password: 	sp0rt2


-- PERF_PROGRAMMA_MUSICALE
SELECT PM.ID_PROGRAMMA_MUSICALE AS ID_PROGRAMMA_MUSICALE, 
		PM.NUMERO AS NUMERO_PROGRAMMA_MUSICALE, 
		PM.TIPO AS TIPO_PM, 
		PM.SUPPORTO_PM AS SUPPORTO_PM, 
		PM.SUPPORTO_PM AS FOGLIO, 
		PM.DATA_ASSEGNAZIONE AS DATA_ASSEGNAZIONE, 
		PM.DATA_RESTITUZIONE AS DATA_RESTITUZIONE, 
		PM.DATA_COMPILAZIONE AS DATA_COMPILAZIONE, 
		PM.STATO AS STATO_PM, 
		PM.DATA_ANNULLAMENTO AS DATA_ANNULLAMENTO, 
		PM.FOGLIO_SEGUE_DI AS FOGLIO_SEGUE_DI, 
		PM.FOGLIO_SEGUE_DI AS PM_RIFERIMENTO, 
		PM.CAUSA_ANNULLAMENTO AS CAUSA_ANNULLAMENTO, 
    NVL(( SELECT COUNT (1) FROM PM_QUADRO_D PQD WHERE PQD.ID_PROGRAMMA_MUSICALE=PM.ID_PROGRAMMA_MUSICALE),0) AS TOTALE_CEDOLE,
    NVL((
      SELECT 
        SUM(CASE
          WHEN INSTR (NVL (DURATA_ESECUZIONE, 0), ':') > 0
          THEN
             -- siamo nel caso in cui ci sono i due punti
             CASE
                WHEN DECODE (REPLACE (TRANSLATE (NVL (SUBSTR (DURATA_ESECUZIONE,1,INSTR (NVL (DURATA_ESECUZIONE, 0), ':') - 1),'0'),'1234567890','##########'),'#'),NULL, NVL (SUBSTR (DURATA_ESECUZIONE,1,INSTR (NVL (DURATA_ESECUZIONE, 0), ':') - 1),'0'),NULL) IS NOT NULL
                AND DECODE (REPLACE (TRANSLATE (NVL (SUBSTR (DURATA_ESECUZIONE,INSTR (NVL (DURATA_ESECUZIONE, 0),':')+ 1),0),'1234567890','##########'),'#'),NULL, NVL ( SUBSTR ( DURATA_ESECUZIONE, INSTR (NVL (DURATA_ESECUZIONE, 0),':')+ 1),0),NULL) IS NOT NULL
                THEN
                   TO_NUMBER (NVL (SUBSTR (DURATA_ESECUZIONE, 1, INSTR (NVL (DURATA_ESECUZIONE, 0), ':') - 1),'0')) * 60 + TO_NUMBER (NVL (SUBSTR (DURATA_ESECUZIONE,INSTR (NVL (DURATA_ESECUZIONE, 0), ':') + 1),'0'))
                ELSE
                   0
             END
          ELSE
             -- siamo nel caso in cui non ci sono i due punti
             CASE
                WHEN DECODE ( REPLACE (TRANSLATE (DURATA_ESECUZIONE,'1234567890','##########'),'#'),NULL, DURATA_ESECUZIONE, NULL) IS NOT NULL
                THEN
                   TO_NUMBER (DURATA_ESECUZIONE)
                ELSE
                   0
             END
      END)
      FROM PM_QUADRO_D PQD WHERE PQD.ID_PROGRAMMA_MUSICALE=PM.ID_PROGRAMMA_MUSICALE
      ),0) AS TOTALE_DURATA_CEDOLE,
    ( SELECT COUNT (1) FROM PROGRAMMA_MUSICALE_EVENTO PME WHERE PME.ID_PROGRAMMA_MUSICALE = PM.ID_PROGRAMMA_MUSICALE ) AS GIORNATE_TRATTENIMENTO      
	FROM PROGRAMMA_MUSICALE PM 
	WHERE 
  PM.STATO='V' 
		AND 
    TRUNC(PM.DATA_158,'MONTH') = TO_DATE('2017-01','YYYY-MM');
             



-- PERF_UTILIZZAZIONE   
SELECT ID_PROGRAMMA_MUSICALE,
       NUMERO_PROGRAMMA_MUSICALE,
       NVL(CODICE_OPERA,'-') AS CODICE_OPERA,
       NVL(TITOLO_COMPOSIZIONE,'-') AS TITOLO_COMPOSIZIONE,
       NVL(COMPOSITORE,'-') AS COMPOSITORE,
       DURATA,
       DURATA_INFERIORE_60SEC,       
 FROM
  (SELECT PM_QUADRO_D.ID_PROGRAMMA_MUSICALE AS ID_PROGRAMMA_MUSICALE,
              PROGRAMMA.NUMERO AS NUMERO_PROGRAMMA_MUSICALE,
              CODICE_OPERA,
              TITOLO AS TITOLO_COMPOSIZIONE,
                      COALESCE (COMPOSITORE,SUBSTR(ELENCO_COMPOSITORI,1,DECODE(INSTR(ELENCO_COMPOSITORI,','),0,300,INSTR(ELENCO_COMPOSITORI,',')-1)),
                      SUBSTR(ELENCO_AUTORI,1,DECODE(INSTR(ELENCO_AUTORI,','),0,300,INSTR(ELENCO_AUTORI,',')-1)),
                      substr(ELENCO_INTERPRETI,1,decode(INSTR(ELENCO_INTERPRETI,','),0,300,INSTR(ELENCO_INTERPRETI,',')-1))) AS COMPOSITORE,
              (SUBSTR(DURATA_ESECUZIONE,1, INSTR(DURATA_ESECUZIONE,':')-1  ) * 60 ) + SUBSTR(DURATA_ESECUZIONE,INSTR(DURATA_ESECUZIONE,':')+1, LENGTH (DURATA_ESECUZIONE)) AS DURATA,
              TO_NUMBER (NVL (DURATA_ESEC_INFERIORE_A, 0)) AS DURATA_INFERIORE_60SEC,
              ID_PM_QUADRO_D
         FROM PM_QUADRO_D PM_QUADRO_D
              JOIN PROGRAMMA_MUSICALE PROGRAMMA ON PM_QUADRO_D.ID_PROGRAMMA_MUSICALE=PROGRAMMA.ID_PROGRAMMA_MUSICALE   
        WHERE PROGRAMMA.STATO='V' 
          AND TRUNC(PROGRAMMA.DATA_158,'MONTH') = TO_DATE('2017-01','YYYY-MM')
          AND PROGRAMMA.COD_VOCE_INCASSO ='2224'
  )
  UNION               
(
  SELECT PM_QUADRO_D.ID_PROGRAMMA_MUSICALE AS ID_PROGRAMMA_MUSICALE,
              PROGRAMMA.NUMERO AS NUMERO_PROGRAMMA_MUSICALE,
              CODICE_OPERA,
              TITOLO AS TITOLO_COMPOSIZIONE,
                      COALESCE (COMPOSITORE,substr(ELENCO_COMPOSITORI,1,decode(INSTR(ELENCO_COMPOSITORI,','),0,300,INSTR(ELENCO_COMPOSITORI,',')-1)),
                      SUBSTR(ELENCO_AUTORI,1,DECODE(INSTR(ELENCO_AUTORI,','),0,300,INSTR(ELENCO_AUTORI,',')-1)),
                      substr(ELENCO_INTERPRETI,1,decode(INSTR(ELENCO_INTERPRETI,','),0,300,INSTR(ELENCO_INTERPRETI,',')-1))) AS COMPOSITORE,
              (substr(durata_esecuzione,1, instr(durata_esecuzione,':')-1  ) * 60 ) + SUBSTR(DURATA_ESECUZIONE,INSTR(DURATA_ESECUZIONE,':')+1, LENGTH (DURATA_ESECUZIONE)) AS DURATA,
              TO_NUMBER (NVL (DURATA_ESEC_INFERIORE_A, 0)) AS DURATA_INFERIORE_60SEC,
              min(ID_PM_QUADRO_D)
         FROM PM_QUADRO_D PM_QUADRO_D
              JOIN PROGRAMMA_MUSICALE PROGRAMMA ON PM_QUADRO_D.ID_PROGRAMMA_MUSICALE=PROGRAMMA.ID_PROGRAMMA_MUSICALE   
        WHERE PROGRAMMA.STATO='V' 
          AND TRUNC(PROGRAMMA.DATA_158,'MONTH') = TO_DATE('2017-01','YYYY-MM')
          AND PROGRAMMA.COD_VOCE_INCASSO !='2224'
  GROUP BY PM_QUADRO_D.ID_PROGRAMMA_MUSICALE,
                PROGRAMMA.NUMERO,
                      COALESCE (COMPOSITORE,substr(ELENCO_COMPOSITORI,1,decode(INSTR(ELENCO_COMPOSITORI,','),0,300,INSTR(ELENCO_COMPOSITORI,',')-1)),
                      substr(ELENCO_AUTORI,1,decode(INSTR(ELENCO_AUTORI,','),0,300,INSTR(ELENCO_AUTORI,',')-1)),
                      substr(ELENCO_INTERPRETI,1,decode(INSTR(ELENCO_INTERPRETI,','),0,300,INSTR(ELENCO_INTERPRETI,',')-1))),
                TITOLO,
                TO_NUMBER (NVL (DURATA_ESEC_INFERIORE_A, 0)),
                    (substr(durata_esecuzione,1, instr(durata_esecuzione,':')-1  ) * 60 ) + 
                         SUBSTR(DURATA_ESECUZIONE,INSTR(DURATA_ESECUZIONE,':')+1, LENGTH (DURATA_ESECUZIONE)) ,
                CODICE_OPERA
                );




